function [img , alpha]=bvmakeoverlayonlyfromplist(plist,nx,ny,nz,act,filter,values,varargin)
% makes an image of size x,y,z
% given a plist from an image of size x,y,z
% useage: [img alpha]=makeimgfromplist(plist,x,y,z);
global AL10STRUCT;

if isempty(AL10STRUCT)
    %AL10STRUCT = load_struct();
    error('Error: be sure to call initjmf first!');
end

optargin=size(varargin,2);
stdargin=nargin-optargin;
colorcount=64;
graycount=64;
value_range=[];
for x=1:2:optargin
    switch lower(varargin{x})
       case 'ncolor'
          colorcount=varargin{x+1};
       case 'ngray'
          graycount=varargin{x+1};
       case 'range'
          value_range=varargin{x+1};
    end
end

if stdargin<7 error('must supply values corresponding to regions'); end
if stdargin<6 filter=0; end
if stdargin<5 act=1500; end
if stdargin<4 nz=34; end
if stdargin<3 ny=256; end
if stdargin<2 nx=256; end

regioncount=size(plist,1);

img=zeros(nx,ny,nz);
alpha=zeros(nx,ny,nz); %0 =totally transparent
shown_regions=zeros(1,regioncount);
shown_regions(filter)=true;

%normvaluesold = @(in)(((in-vmin)/(vmax-vmin))*63+1+64);
if isempty(value_range) 
    vmax=max(values);
    vmin=min(values);
else
    vmin=value_range(1);
    vmax=value_range(2);
end
normvaluesold = @(in)(max(1,min(((in-vmin)/(vmax-vmin))*(colorcount-0)+1,colorcount))+ graycount);
values=normvaluesold(values);
voxel=0;
for roi=1:size(plist,1)
  for pnum=1:size(plist,2)
    xp=plist(roi,pnum,1);
    yp=plist(roi,pnum,2);
    zp=plist(roi,pnum,3);
    if(xp>0 && yp>0 && zp>0) 
      voxel=voxel+1;
      if shown_regions(roi)
          thisvalue=values(find(filter==roi,1));
          img((xp-1)*4+[1 2 3 4],(yp-1)*4+[1 2 3 4],zp)=thisvalue;
          alpha((xp-1)*4+[1 2 3 4],(yp-1)*4+[1 2 3 4],zp)= 0.7;
      end
    end
  end
end
end

function res = normvalues(in ,vmin, vmax)
    if vmin < 0 
       if abs(vmin) > vmax 
           vmax = abs(vmin);
       else
           vmin = -vmax;
       end
     end
    res = 63*(in-vmin)/(vmax-vmin)+1+64;
end