function img  = bvshow_img_array_ovr_new(a,alpha,nx,ny,nz,values,p16p,varargin)
    global AL10STRUCT;
    global AL10P16;     
    if p16p
         underlay=AL10P16;
     else
         underlay=AL10STRUCT;
    end
    optargin=size(varargin,2);
    stdargin=nargin-optargin;
    colorcount=64;
    graycount=64;
    value_range=[];
    layout=[2 4];
    slices=3:5:34;
    for x=1:2:optargin
        switch lower(varargin{x})
            case 'ncolor'
              colorcount=varargin{x+1};
            case 'ngray'
              graycount=varargin{x+1};
            case 'range'
              value_range=varargin{x+1};
            case 'layout'
              layout=varargin{x+1};
            case 'slices'
              slices=varargin{x+1};
            otherwise
              disp(['Ignoring argument ' varargin{x} ]);;
        end
    end
         
    hfigure=figure;
    set(gcf,'color','w');
    fontsize=18;
    clf;
    mycmap=[gray(graycount);jet(colorcount)];  
    colormap(mycmap);
    set(gcf, 'Position', [20   427   985   570]) ;

    layout=set_figure_position(hfigure,layout,slices);

    al10max=1742;
    al10min=0;
    if isempty(value_range) 
        valmax=max(values);
        valmin=min(values);
    else
        valmin=value_range(1);
        valmax=value_range(2);
    end

    normal10 = @(in)(((in-al10min)/(al10max-al10min))*(graycount-1)+1);

    ttz_slices = [70    67  64  61  ...
                          57    54  51  48  45  ...
                          42    38  35  32  29  ...
                          26    23  19  16  13  ...
                          10     7   4   0  -2  ...
                          -5    -8 -11 -14 -17 ...
                         -19   -22 -25 -28 ...
                         -31]+2;

    xmult=1/layout(2);
    ymult=1/layout(1);
    counter=0;
   for j=slices
          counter=counter+1;
          a1=a(:, :, j);
          al10=underlay(:,:,j);
          alpha1=alpha(:,:,j);
          h=subplot('Position', [0.00+mod((counter-1),layout(2))*xmult, .99-(floor((counter-1)/layout(2))+1)*ymult, xmult, ymult]);
          image(graycount+1-normal10(al10))
          axis off;
          hold on;
          ih=image(a1); %******************************************
          set(ih,'AlphaData',alpha1);
          axis square;
          axis off;
          hold on;
          text(136,-4,['\bf ' 'z = ' num2str(ttz_slices(j), '%4d') 'mm'], ...
                                 'FontUnits','normalized','FontSize',.15, ...
                                 'HorizontalAlignment','center','VerticalAlignment','Cap')
          hold off;
   end
    counter=counter+1;
    h=subplot('Position', [0.00+mod((counter-1),layout(2))*xmult, .99-(floor((counter-1)/layout(2))+1)*ymult, xmult, ymult]);
    image([ones(256,64)*graycount repmat(colorcount+graycount-(floor((0:255)'*(colorcount/256))),1,128) ones(256,64)*graycount]);
    axis square;
    hold on;
    
    if abs(valmin)<1 && abs(valmax)<1
        formatstring='%4.2f';
    elseif abs(valmin)<10 && abs(valmax)<10
        formatstring='%4.2f';
    else
        formatstring='%5.0f';
    end
    text(196-8,250,['\bf ' num2str(valmin, formatstring)],'FontUnits','normalized', ...
                  'FontSize',0.1,'VerticalAlignment','Baseline'); %250
    text(196-8,0,['\bf ' num2str(valmax,formatstring)],'FontUnits','normalized', ...
                'FontSize',0.1,'VerticalAlignment','Cap'); %6
    if valmin < 0 && valmax > 0
        text(196-8,256-256*(0-valmin)/(valmax-valmin), ...
             ['\bf ' num2str(0,formatstring)],'FontUnits','normalized','FontSize',0.1,'VerticalAlignment','Middle');%'\bf '
    end
    axis off;
    img = a;
end

function layout = set_figure_position (hfigure, layout,slices, defaultsizep,keep_positionp)
    % At creation:  true,false
    % setting anything but layout: false,false
    % setting layout: true, true
    if nargin <5 keep_positionp = false; end
    if nargin < 4 defaultsizep = true; end
    total_panels=prod(layout);
    total_required=length(slices)+1;
    if total_required>total_panels || total_required< 0.75*total_panels
        % Modify the specified layout to accommodate
        % all slices and colorbar if needed
        newx=ceil(sqrt(total_required))-1;
        newy=ceil(sqrt(total_required))+1;
        while newx*newy<total_required
            newy=newy+1;
        end
        while total_required<=(newx-1)*newy
            newx=newx-1;
        end
        layout=[newx newy];
    end
    xmult=1/layout(2);
    ymult=1/layout(1);
    screensize=get(0,'screensize');
    if defaultsizep
        figure_height = 256*layout(1);
        figure_width = 256*layout(2);
        while (figure_height > screensize(4) || figure_width > screensize(3))
         figure_height=figure_height*.5;
         figure_width=figure_width*.5;
        end
        if keep_positionp
            curpos=get(BV.hfigure,'Position');
            set(hfigure, 'Position', [curpos(1),curpos(2)-(figure_height+20-curpos(4)), figure_width, figure_height+20]);
        else
            set(hfigure, 'Position', [20, screensize(4)-100-figure_height, figure_width, figure_height+20]);
        end
    end
end