function [origin, points, vectors remapped mapping rotation] = findSubspace(factors,transform,latent,means,stds)
[~, mapping] = ldajra(factors',.75,3); %find a manpping onto a 3-D subspace
normed=factors-repmat(mapping.mean',1,4); %norm factor so each dimension averages 0
describe(:,1)=regress(normed(:,1),mapping.M);  %determine the best mapping of 4 factors to 3-D subspace
describe(:,2)=regress(normed(:,2),mapping.M);
describe(:,3)=regress(normed(:,3),mapping.M);
describe(:,4)=regress(normed(:,4),mapping.M);
origin=reconstruct(mapping.mean'+mapping.M*describe(:,3),transform,latent,means,stds)'; %describe the origin in the voxel space
describe=describe-repmat(describe(:,3),1,4); %recalculate points with reference to new origin
[vals rotation]= findRotation(describe,10); %find a useful rotation of axis.
remapped=mapping.M*rotation; %find description of new axis
points=rotation'*describe;  %find new coordinates of points
[~,b]=max(points); %find major direction of each point
points=points([b(1),b(2),b(4)],:); %reorder dimensions
remapped=remapped(:,[b(1),b(2),b(4)]); %reorder desciption
vectors=reconstruct(mapping.M*rotation,transform,latent,means,stds)'-repmat(means',1,3); %construct description of vectors in voxel space
