function [lkh, means1, params1, probpairs1]=hsmmEstimateold(activations,means,params,thresh)
ntypes=1;
nstates = size(means,2);
paramsFeatures=[1:nstates];
maxlength=max(activations(:,1));
A = cat(1,cat(2,zeros(nstates,1),eye(nstates)),cat(2,1,zeros(1,nstates)));
nscans=size(activations,1);
conditions=ones(nscans,1);
nvals = size(activations,2)-1;
M = nstates+1;
template = zeros(M,1);
template(M)=1;
D=maxlength;               %The maximum duration of a trial
Pest=zeros(M,D,ntypes);
Pest1=zeros(M,D+1,ntypes);
times=cat(2,.5,[2:2:maxlength*2]);
Ah = A; %Remember the transition matrix before skips
probpairs=zeros(nscans,M-1);
ntrials=zeros(ntypes,1);
x=find(activations(:,1)==1);
y=cat(1,x(2:end,1)-1,nscans);
if length(size(params)) ~= 3
   params=repmat(params,[1 1 ntypes]);
end
means1=means;
params1=params;
paramsA=params(:,2,1);
%creates a start state vector starting in the rest state
% The two lines above create a sequence of events with sinngle rest scans
% forced
% beteen the trials.  It is a matrix B where the columns represent the
% original scans plus the inserted rest scans and the rows represent the
% states with the last state being the rest state.  The hsmm is forced to
% go into the rest state on rest scans because the probability all other
% states is set to zero on this scan and the rest state has probability 1.
% On all other scans the rest state has probability zero and the other
% states have the probability of that scan.  These probabilities sum to 1
% but basetot reflects an additional log likelikelihood to be added in.
%----------------------------------------------------
P=zeros(M,maxlength,ntypes);
P(M,1,:) = 1;
if thresh == 0
    bound = 1;
else
    bound = 200;
end
for ir=1:bound
    for i = 1:M-1
        for j = 1:ntypes
            P(i,:,j)=gamma21P2(params(i,1,j),params(i,2,j),maxlength)';
        end
    end
    %throughout the loop  about-to-be-calculated basetot and lkh represent
    %the value of the new parameters.   basetot1 and lkh1 represent the
    %values of the old parameters
    if ir > 1
        lkh1=lkh;
        basetot1=basetot;
    else
        lkh1=-Inf;
        basetot1=-Inf;
    end
    basetot = 0;
    lkh = 0;
    Pest(:)=0;
    for iz = 1:ntypes
        values=activations(conditions==iz,:);
        trials=values(:,1);
        values=values(:,2:end);
        ntrials(iz)=sum(trials==1);
        [B basetotx] = constructProbs2(values,means,trials);
        basetot=basetot+basetotx;
        B = B';
        T=size(B,2);    %The total number of scans
        bmx=zeros(M,T);
        S=zeros(M,T);
        E=zeros(M,T);
        Best=zeros(M,T); 
        A = skipsP1(Ah,params(:,:,iz),maxlength);
%++++++++++++++++++     Forward     +++++++++++++++++
        %---------------    Initialization    ---------------
        ALPHA=zeros(M,D); ALPHA(M,1)=1;
        bmx(M,1)=1;			%Equation (2)
        E(M,1)=1;	%Equation (5)
        S(:,1)=A(M,:)';
%---------------    Induction    ---------------
        for t=2:T
            ALPHA=[repmat(S(:,t-1),1,D-1).*P(:,1:D-1,iz)+repmat(bmx(:,t-1),1,D-1).*ALPHA(:,2:D),S(:,t-1).*P(:,D,iz)];	 
            r=(B(:,t)'*sum(ALPHA,2));		%Equation (3) probability of scan
            bmx(:,t)=B(:,t)./r;			%Equation (2)   probability of state occupancy
            E(:,t)=bmx(:,t).*ALPHA(:,1);		%Equation (5) exiting state
            S(:,t)=A'*E(:,t);     %Equation (6) and going into another state
            lkh=lkh+log(r);
        end
%++++++++ Backward and Parameter Restimation ++++++++
% re-estimate parameters
    %---------------    Initialization    ---------------
            GAMMA=bmx(:,T).*sum(ALPHA,2);
            Best(:)=0;
            Best(:,T)=GAMMA;
            BETA=repmat(bmx(:,T),1,D);				%Equation (7)
            Ex=sum(P(:,:,iz).*BETA,2);					%Equation (8)
            Sx=A*Ex;						%Equation (9)
    %---------------    Induction    ---------------
            for t=(T-1):-1:1
                Pest(:,:,iz)=Pest(:,:,iz)+repmat(S(:,t),1,D).*BETA;
                GAMMA=GAMMA+E(:,t).*Sx-S(:,t).*Ex;
                GAMMA(GAMMA<0)=0;           % eleminate errors due to inaccurace of the computation.
                Best(:,t)=Best(:,t)+GAMMA;
                BETA=repmat(bmx(:,t),1,D).*[Sx,BETA(:,1:D-1)];	%Equation (14)
                Ex=sum(P(:,:,iz).*BETA,2);					%Equation (8)
                Sx=A*Ex;						%Equation (9)
            end 
            probpairs(conditions==iz,:)=Best(1:nstates,not(Best(nstates+1,:)>.99))';
            Pest(:,:,iz)=Pest(:,:,iz)+repmat(template,1,D).*BETA;              
       Pest(:,:,iz)=Pest(:,:,iz).*P(:,:,iz);
       for jj = 1:M
            Pest1(jj,:,iz)=cat(2,ntrials(iz) -sum(Pest(jj,:,iz)),Pest(jj,:,iz));
       end
    end
   if thresh~=0
       for iz = 1:M-1
            paramsA(iz)=fminsearch(@(x)gammajoint6(cat(2,paramsFeatures(:,iz),reshape(Pest1(iz,:,:),maxlength+1,ntypes)'),x),paramsA(iz));
                for i = 1:max(paramsFeatures(:,iz))
                    indi=find(paramsFeatures(:,iz)==i);
                    pestx=sum(Pest1(iz,:,indi),3);
                    params(iz,1,indi)=(pestx*times'/sum(pestx))/paramsA(iz);
                end
            params(iz,2,:)=paramsA(iz,1);
       end 
       for i = 1:M-1
            means(:,i)= sum(values.*repmat(probpairs(:,i),1,nvals))/sum(probpairs(:,i)); 
       end
       if ir>1 
             %[ir, basetot+lkh-basetot1-lkh1]
       end
       if ir > 1 && (basetot+lkh-basetot1-lkh1)<thresh  
            break
       else
            basetot1=basetot;
            probpairs1=probpairs;
            params1=params;
            means1=means;
       end
       lkh1=lkh;
   else
       lkh1 = lkh;
       basetot1=basetot;
       probpairs1=probpairs;
       break
   end           
end
lkh=max(lkh+basetot,lkh1+basetot1);